;------------------------------------------------------;
;  INT 01, INT 03   Debug.          ;
;    DOS BOX,             ;
; DOS  INT 01, ,                 ;
; SPMX43PR.EXE -              ;
;  .                             ;
;                                                      ;
;     DOS,    ;
;    ( SPMX42).    ;
;            ;
;  (64035016 )        ;
;  "ABCD" -   Windows         ;
;   [Alt]+[Enter].                        ;
;    -   ,     ;
;    DOS.            ;
;   Windows    .     ;
;            ;
;   Windows.                               ;
;                                                      ;
;      Created:   29-March-2024                        ;
;                                                      ;
;------------------------------------------------------;
;   1,22  (1254 )   1,09  (1124 )

.MODEL TINY
.186
STACK_SIZE = 128; 512

.CODE
    ORG  100H
STRATUP:
    MOV  AX,OFFSET END_PROGRAMM + STACK_SIZE
    MOV  SP,AX    ;    + 
    MOV  AX,0003H ;  
    INT  10H      ;    

BEGIN:
    PUSH AX
    ;   INT 01h, INT 03h
    CLI
    MOV    AX,3501H     ; DOS Services  ah=function 35h
    INT    21H          ; get intrpt vector al in es:bx
    MOV    WORD PTR DATA_0001,BX ; Old fun INT 01h vector OFFset
    MOV    WORD PTR DATA_0002,ES ; Old fun INT 01h vector SEGment

    MOV    AX,3503H     ; DOS Services  ah=function 35h
    INT    21H          ; get intrpt vector al in es:bx
    MOV    WORD PTR DATA_0003,BX ; Old fun INT 03h vector OFFset
    MOV    WORD PTR DATA_0004,ES ; Old fun INT 03h vector SEGment

    MOV    AX, 2501H    ; set intrpt vector in al
    MOV    DX, OFFSET INT01;  intrpt vector 01
    INT    21H

    MOV    AX, 2503H   ; set intrpt vector in al
    MOV    DX, OFFSET INT03; ;  intrpt vector 03
    INT    21H
    STI

  MOV  AH,30H;   
  INT  21H   ; AL -   
  XCHG AH,AL ; AH -   
  CMP  AX,0200H ;    
  JNB  GOGO  ;    -98

  POP  AX

  MOV  DX,OFFSET ERR0
  MOV  AH,09H ;   
  INT  21H    ;  
  JMP  WXIT   ; 

GOGO:
;       ,  ...
  MOV  AH,19H;  
  INT  21H   ; AL - 0=A, 1=B, 2=C ...

  MOV  DL,AL ;-  47h
  ADD  AL,41H;    
  MOV  CS:BYTE PTR PATH,AL ;    

  INC  DX    ;  : 0=, 1=A, 2=B, 3=C ...
  MOV  AX,OFFSET CPTH
  MOV  SI,AX ;   
  MOV  AH,47H;  
  INT  21H   ; AX -    CF 
  JNC  GOAG  ; CF = 1,  

  POP  AX

  MOV  DX,OFFSET ERR3
  MOV  AH,9H  ;   
  INT  21H    ;   
  JMP  WXIT   ; 

GOAG:
  XOR  AX,AX
  LEA  SI,CPTH;   
  CLD
GO1:
  LODSB       ; al <- [si], si+1
  OR   AX,AX
  JNZ  GO1
  DEC  SI
  PUSH SI     ;    
  POP  DI
  LEA  SI,FILE;    
GO2:
  LODSB       ; al <- [si], si+1
  STOSB       ; al -> [di], di+1
  OR   AX,AX
  JNZ  GO2
  XOR  CX,CX

;    ,     .
;  MOV  AX,0  ;  
;  INT  33H

;  MOV  AX,2  ;  
;  INT  33H

;  MOV  CX,4  ;
;  MOV  DX,4  ;
;  MOV  AX,4  ; . 
;  INT  33H

;  MOV  AX,1  ;  
;  INT  33H

;  MOV  AX,000CH  ;    0000.1011
;  MOV  CX,000BH  ; 0000.0001b -   
                 ; 0000.0010b -   
                 ; 0000.0100b -   
                 ; 0000.1000b -   
                 ; 0001.0000b -   
;  MOV  DX,OFFSET MOUSE_SUB ; ES:DX -  
;  INT  33H
  POP  AX
;
;     
;
  PUSH CS
  POP  ES
  MOV  AX,OFFSET END_PROGRAMM + STACK_SIZE
  MOV  CL,4
  SHR  AX,CL  ;     
  INC  AX     ;  1      
  MOV  BX,AX  ;   
  MOV  AH,4AH ;  
  INT  21H
  JNC  SHORT RUN ; CF = 1,  

  MOV  DX,OFFSET ERR1
  MOV  AH,09H  ;   
  INT  21H    ;   
  JMP  SHORT WXIT ; 

RUN:
  PUSH  DS
  PUSH  ES
  PUSH  BP

  MOV  WORD PTR CS:OLDSTK[0],SP ;    
  MOV  WORD PTR CS:OLDSTK[2],SS ;   

;  PUSHF
;  POP    AX
;  OR     AX,0000000100000000B ; Set single step flag
;  PUSH   AX
;  POPF
;--     single step
;--     ,    INT 03H

  MOV  AH,09H       ; INT 21H Fun 09 - Disp String to '$'
  MOV  DX, OFFSET MESSG_BEG ;   ' Start ...'
  INT  21H          ;  ,  ,  

;   DOS Fn 4BH:     = EXEC
  MOV  BX,OFFSET ENVR
  ; ES:BX   EPB (EXEC Parameter Block -   EXEC)
  MOV  DX,OFFSET PATH;
  ; DS:DX    ASCIIZ  : "d:\\",0.
  ;     ,    .
  MOV  AX,4B00H  ; 00h -    
                 ; 03h -   
  INT  21H       ;   ,  
;    single step    .   INT 03H.

  MOV    BX,0FFFFH; ,    
  MOV    DX,BX    ;  single step
  MOV    CX,DX    ;  

  CLI
  MOV  SP, WORD PTR CS:OLDSTK[0] ;   
  MOV  SS, WORD PTR CS:OLDSTK[2] ;   
  STI

  POP  BP
  POP  ES
  POP  DS
  JNC  SHORT EXIT

ERROR:
  MOV  DX,OFFSET ERR2
  MOV  AH,09H   ;   
  INT  21H      ;    

WXIT:
  PUSH    AX
  MOV     AH,00H;   
  INT     16H   ; AL = ASCII 
  POP     AX    ; AH =      ASCII

EXIT:
    CLI
    PUSH   DS

    PUSH   DS
    POP    ES
;--    INT 01h, INT 03h  
    LDS    DX,DWORD PTR ES:DATA_0001; Load 32 bit ptr INT 01h vector
    MOV    AX,2501H     ; Old fun INT 01h vector
    INT    21H          ; DOS Services  ah=function 25h
                        ; set intrpt vector al to ds:dx
    LDS    DX,DWORD PTR CS:DATA_0003; Load 32 bit ptr INT 03h vector
    MOV    AX,2503H     ; Old fun INT 03h vector
    INT    21H          ; DOS Services  ah=function 25h
                        ; set intrpt vector al to ds:dx
    POP    DS
    STI
;------------------   
;  PUSH AX
;  MOV  AX,000CH  ;  
;  MOV  CX,0000H
;  INT  33H
;  POP  AX

  MOV  AX,0003H ;    
  INT  10H      ;    

  MOV  AH,09H   ; INT 21H Fun 09 - Disp String to '$'
  MOV  DX, OFFSET MESSG_EXT ;   ' Exit in DOS.'
  INT  21H

  PUSH    AX    ;  - ,   .
  MOV     AH,00H;   
  INT     16H   ; AL = ASCII 
  POP     AX    ; AH =      ASCII

  MOV  AX,4C00h ;   DOS  errorcode AL = 00h
  INT  21H      ;
;---------- THE END --------------------------------------------------
MESSG_BEG   DB    0DH, 0AH
            DB    ' Starting selected application...', 0DH, 0AH, '$'
MESSG_EXT   DB    ' Press any key to return in DOS.', 0DH, 0AH, '$'

DATA_0001   DW      0000H;     Old fun INT 01h vector OFF
DATA_0002   DW      0000H;     Old fun INT 01h vector SEG

DATA_0003   DW      0000H;     Old fun INT 03h vector OFF
DATA_0004   DW      0000H;     Old fun INT 03h vector SEG

;--------   INT 01h -  single step -----------------
INT01      PROC    NEAR
;    IRET

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DS
    PUSH   ES
    PUSH   DI

    PUSH   CS
    POP    DS

;    JMP SHORT TESTCLR

;---     ------------
;    MOV    AH,00H;   
;    INT    16H   ; AL = ASCII 

;--  INT01    -------
;---       ---
;    PUSH   DX
;    MOV    DX,0101H ; DH,DL = ,  (  0)
;    MOV    AX,0200H ;   .
;    INT    10H      ; BH =  ,     
;    POP    DX

    MOV    AL,BYTE PTR SYMB_TST
    CMP    AL,20H;    
    JZ     SETSTAR;    '*'

    MOV    AL,20H;  
    MOV    BYTE PTR SYMB_TST,AL
    MOV    BL,96H; - -
    MOV    CX,1
    MOV    AH,0EH;       ( )
    INT    10H

    MOV    AL,'+'
    MOV    BL,96H; - -
    MOV    CX,1
    MOV    AH,0EH;       ( )
    INT    10H

    MOV    AL,0DH;  
    MOV    BL,96H; - -
    MOV    CX,1
    MOV    AH,0EH;       ( )
    INT    10H
    JMP    TESTCLR

SETSTAR:
    MOV    AL,20H;  
    MOV    BL,95H; -
    MOV    CX,1
    MOV    AH,0EH;       ( )
    INT    10H

    MOV    AL,'*'
    MOV    BYTE PTR SYMB_TST,AL
    MOV    BL,95H; -
    MOV    CX,1
    MOV    AH,0EH;       ( )
    INT    10H

    MOV    AL,0DH;  
    MOV    BL,95H; -
    MOV    CX,1
    MOV    AH,0EH;       ( )
    INT    10H

TESTCLR:
    CMP    DX,0FFFFH;
    JNZ    INTRET; ALLRET
    CMP    BX,0FFFFH;
    JNZ    INTRET; ALLRET
    CMP    CX,0FFFFH;
    JNZ    INTRET; ALLRET

;    PUSH   AX
;    PUSH   DX
;    PUSH   DS
;    JMP    SHORT CLRFLG

;    MOV    AH,10H; Keyboard AL = Code AH = ext.Code
;    INT    16H

;    CMP    AL,1BH; Key AL = 'Esc'
;    JNZ    INTRET
CLRFLG:
;    MOV    AH,09H       ; INT 21H Fun 09 - Disp String to '$'
;    MOV    DX, OFFSET MESSG_CLR ;   'Clear Debug INT 01 flag.'
;    INT    21H

    POP    DI
    POP    ES
    POP    DS
    POP    DX
    POP    CX
    POP    BX
    POP    AX
    MOV    WORD PTR CS:SAVE_AX,AX ; Save AX

    POP    AX
    MOV    WORD PTR CS:SAVE_IP,AX ; Save IP

    POP    AX
    MOV    WORD PTR CS:SAVE_CS,AX ; Save CS

    POP    AX           ; AX = Flags
;   OR     AX,0000000100000000B
    AND    AX,1111111011111111B ; Clear Debug INT 01 flag
    PUSH   AX           ; Save Flags

    MOV    AX, WORD PTR CS:SAVE_CS ;
    PUSH   AX

    MOV    AX, WORD PTR CS:SAVE_IP ;
    PUSH   AX

    MOV    AX, WORD PTR CS:SAVE_AX ;
    JMP    SHORT ALLRET

INTRET:
    POP    DI
    POP    ES
    POP    DS
    POP    DX
    POP    CX
    POP    BX
    POP    AX
;   In Real Address Mode, IRET pops the instruction pointer IP, CS,
;   and the flags register from the stack and resumes the interrupted routine.
;    IRET   :
;   1)       IP;
;   2)   SP  2;
;   3)       CS;
;   4)   SP  2;
;   5)        ;
;   6)   SP  2.
ALLRET:
    IRET

MESSG_CLR   DB    ' Clear Debug INT 01 flag.', 0DH, 0AH, 0DH, 0AH,'$'
SAVE_AX     DW    0000H;     Old AX
SAVE_IP     DW    0000H;     Old IP
SAVE_CS     DW    0000H;     Old CS
SYMB_TST    DB    20H;
INT01      ENDP

;   SPMX44PR.EXE -  
;      9AH   0CCH - INT03
; 0000407C: 9A00006B0A                   call        00A6B:00000
; 00004081: 9A0D00090A                   call        00A09:0000D
; 00004086: 9A6F194306                   call        00643:0196F
INT03      PROC    NEAR
;    PUSH   AX
;    MOV    AX,0E07H;  BEEP,  Windows7  
;    INT    10H
;    POP    AX

    MOV    WORD PTR CS:TEMP_AX,AX ; Save AX

    POP    AX
    MOV    WORD PTR CS:TEMP_IP,AX ; Save IP

    POP    AX
    MOV    WORD PTR CS:TEMP_CS,AX ; Save CS

    PUSH   DS
    PUSH   ES
    PUSH   DI
    PUSH   DX

    PUSH   CS
    POP    DS

    MOV    AH,09H       ; INT 21H Fun 09 - Disp String to '$'
    MOV    DX, OFFSET MESSG_SET ;   'Set Debug INT 01 flag.'
    INT    21H

;     MOV    AH,00H;   
;     INT    16H   ; AL = ASCII 

    MOV    AX,WORD PTR CS:TEMP_IP ; Get IP -> (90h - "I" = 49h)
    DEC    AX;    
    MOV    DI,AX

    MOV    AX,WORD PTR CS:TEMP_CS ; Get CS
    MOV    ES,AX

    MOV    AL,ES:[DI];   

    SHR    AX,1
    SHR    AX,1
    SHR    AX,1
    SHR    AX,1
    AND    AL,0FH
    ADD    AL,40H

    PUSH   AX
    XOR    AX,AX;    
    MOV    DI,AX;  DI = 0000h

    MOV    AX,0B800H;  
    MOV    ES,AX;       
    POP    AX

    MOV    ES:[DI],AL;    

    MOV    AH,00H;   
    INT    16H   ; AL = ASCII 

    MOV    AX,WORD PTR CS:TEMP_IP ;
    DEC    AX;     (0CCh - "L" = 4Ch)
    MOV    WORD PTR CS:TEMP_IP,AX ;
    MOV    DI,AX

    MOV    AX,WORD PTR CS:TEMP_CS ; Get CS
    MOV    ES,AX

    MOV    AL,9AH;   -  0CCH

    MOV    ES:[DI],AL;   

    POP    DX
    POP    DI
    POP    ES
    POP    DS

    POP    AX           ; AX = Flags
    OR     AX,0000000100000000B  ; Set Debug INT 01 flag
;    AND    AX,1111111011111111B ; Clear Debug INT 01 flag
    PUSH   AX           ; Save Flags

    MOV    AX, WORD PTR CS:TEMP_CS ;
    PUSH   AX

    MOV    AX, WORD PTR CS:TEMP_IP ;
    PUSH   AX

    MOV    AX, WORD PTR CS:TEMP_AX ;

    IRET

MESSG_SET   DB    ' Set Debug INT 01 flag.', 0DH, 0AH, '$'
TEMP_AX     DW    0000H;     Old AX
TEMP_IP     DW    0000H;     Old IP
TEMP_CS     DW    0000H;     Old CS

INT03      ENDP


MOUSE_SUB:
  PUSH    AX
  PUSH    BX
  PUSH    CX
  PUSH    DX
  PUSH    SI
  PUSH    DI
  PUSH    ES
;    :
; AX contains a bit mask identifying which event has occurred;
;  = -
; DX = Y-
TYTA:
  TEST AL,01H; -    
  JNZ  SHOW;  0000.0001b 

  TEST AL,08H; -   
  JNZ  THERE ; rdot;  0000.1000b 

  CMP  DX,20H;  
  JNC  RDOT  ;    
  CMP  CX,20H; 3232 
  JNC  RDOT  ;    

HERE:
;  INT 16H Fn 00H  AL=0,  AH  
;   ASCII: F10 = 44h; 38h = 09h   9
  MOV  CL,00H;  [F10]
  MOV  CH,44H
  MOV  AH,05H;      .
  INT  16H
  MOV  CL,38H;  [8]
  MOV  CH,09H
  MOV  AH,05H;      .
  INT  16H
  JMP  QUIT

THERE:
  CALL CLBD;    
  JMP  QUIT

RDOT:
; DX,CX = ,
  CALL ANAKEYS;  , '' 
;--------------------------------------------------
; 0  Black        8   Gray           0000.1000
; 1  Blue         9   Bright Blue    0000.1001
; 2  Green        10  Bright Green   0000.1010
; 3  Cyan         11  Bright Cyan    0000.1011
; 4  Red          12  Bright Red     0000.1100
; 5  Magenta      13  Bright Magenta 0000.1101
; 6  Brown        14  Bright Yellow  0000.1110
; 7  White        15  Bright White   0000.1111
;--------------------------------------------------
;       
;  push ax
;  mov  ax,2  ;  
;  int  33h
;  pop  ax

;  mov  al,0eh; 
;sdot:
; DX,CX = ,
;  call disp
;  mov  ah,0ch;  
;  int  10h

  MOV  AX,CS:WORD PTR PRESS_KEY
  CMP  AX,0FFFFH
  JNZ  SHOW

  MOV  AX,0000H
  MOV  CS:WORD PTR PRESS_KEY,AX
  CALL CLEAR

SHOW:
;  PUSH AX
;  MOV  AX,1  ;  
;  INT  33H
;  POP  AX
QUIT:
  POP     ES
  POP     DI
  POP     SI
  POP     DX
  POP     CX
  POP     BX
  POP     AX
  RETF  ;  -  
;----------------------------------------------

CLBD:
  MOV  AX,CS:WORD PTR PRESS_KEY
  CMP  AX,0FFFFH
  JZ   SETT
TSIT:
  MOV  AX,1700H;   CLIPBOARD.
  INT  2FH
  CMP  AX,1700H; Clipboard 
  JNZ  OPKB
ERRO:
;     BL      
; .   7  0,       ,
;   7  1,        XOR.
  PUSH AX
  MOV  AL,20H;   
  MOV  BL,96H; - - 
  MOV  CX,1
  MOV  AH,0EH;       ( )
  INT  10H

  MOV  AL,'*'
  MOV  BL,95H; - - 
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,13 ; 0DH = CR -   
  MOV  BL,95H; - - 
  MOV  CX,1
  MOV  AH,0EH
  INT  10H
  POP  AX
SETT:
  JMP  SETI

OPKB:
  MOV  AX,1701H;  CLIPBOARD
  INT  2FH
  OR   AX,AX;       CLIPBOARD
  JZ   ERRO

  MOV  AX,1702H;  CLIPBOARD
  INT  2FH

  PUSH CS
  POP  ES
  MOV  BX,OFFSET CLIPBD_MESS ; ES:BX -    
  MOV  SI,0
  MOV  CX,5; SI:CX -   
  MOV  DX,1;  -  ,   CLIPBOARD:
  MOV  AX,1703H;    WINDOWS CLIPBOARD.
  INT  2FH
  OR   AX,AX;    Clipboard
  JZ   ERRO

  MOV  AX,1708H;  CLIPBOARD
  INT  2FH
  OR   AX,AX;       Clipboard
  JNZ  FIN
  JMP  ERRO
FIN:
  MOV  AX,0FFFFH; ,     Clipboard
  MOV  CS:WORD PTR PRESS_KEY,AX

  PUSH AX
  MOV  AL,CS:BYTE PTR FIRST;     Clipboard
  OR   AL,AL
  JNZ  SECN

  MOV  AL,0FFH            ; ,    
  MOV  CS:BYTE PTR FIRST,AL
  JMP  TYT                ;    '*'
SECN:
  MOV  AL,20H             ;      Clipboard
  MOV  BL,96H             ;   XOR  '*'
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,'*'
  MOV  BL,96H; -
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,13
  MOV  BL,96H
  MOV  CX,1
  MOV  AH,0EH
  INT  10H
TYT:
;----------------------------   XOR  '*'
  MOV  AL,20H               ;   
  MOV  BL,CS:BYTE PTR COLLOR;      
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,'*'
  MOV  BL,CS:BYTE PTR COLLOR
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,13  ; 0DH = CR -   
  MOV  BL,CS:BYTE PTR COLLOR
  MOV  CX,1
  MOV  AH,0EH
  INT  10H
  POP  AX
SETI:
  RET

CLEAR:
;   XOR  '*'   
  PUSH AX
  MOV  AL,20H ; 
  MOV  BL,CS:BYTE PTR COLLOR;   
  MOV  CX,1   ;    ,  - ...
  MOV  AH,0EH
  INT  10H

  MOV  AL,'*'
  MOV  BL,CS:BYTE PTR COLLOR
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,13 ; 0DH = CR -   
  MOV  BL,CS:BYTE PTR COLLOR
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,20H ; 
  MOV  BL,96H
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,'*'
  MOV  BL,96H
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  MOV  AL,13 ; 0DH = CR -   
  MOV  BL,96H
  MOV  CX,1
  MOV  AH,0EH
  INT  10H

  POP  AX
  RET

ANAKEYS:
  PUSH SI
  PUSH DS

  PUSH CS
  POP  DS
; DX,CX = ,

  MOV  SI,OFFSET ENTCRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXT0

  MOV  CL,0DH;  [Enter]
  MOV  CH,1CH; -
  MOV  AH,05H;      .
  INT  16H
NEXT0:
  MOV  SI,OFFSET ESCCRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXT1

  MOV  CL,1BH;  [Esc]
  MOV  CH,01H; -
  MOV  AH,05H;      .
  INT  16H
NEXT1:
  MOV  SI,OFFSET DELCRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXT2

  MOV  CL,2EH;  [Del]
  MOV  CH,53H; -
  MOV  AH,05H;      .
  INT  16H
NEXT2:
  MOV  SI,OFFSET UPKCRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXT3

  MOV  CL,00H;  [UPKey] 26h
  MOV  CH,48H; -
  MOV  AH,05H;      .
  INT  16H
NEXT3:
  MOV  SI,OFFSET DNKCRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXT4

  MOV  CL,00H;  [DownKey] 28h
  MOV  CH,50H; -
  MOV  AH,05H;      .
  INT  16H
NEXT4:
  MOV  SI,OFFSET LEFCRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXT5

  MOV  CL,00H;  [LeftKey] 25h
  MOV  CH,4BH; -
  MOV  AH,05H;      .
  INT  16H
NEXT5:
  MOV  SI,OFFSET RGTCRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXT6

  MOV  CL,00H;  [RightKey] 27h
  MOV  CH,4DH; -
  MOV  AH,05H;      .
  INT  16H
NEXT6:
  MOV  SI,OFFSET F12CRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXTA

  MOV  CL,00H;  [F12]
  MOV  CH,86H
  MOV  AH,05H;      .
  INT  16H
NEXTA:
  MOV  SI,OFFSET F11CRD
  CALL TESTBOX
  OR   AX,AX
  jnz  NextB

  MOV  CL,00H;  [F11]
  MOV  CH,85H
  MOV  AH,05H;      .
  INT  16H
NEXTB:
  MOV  SI,OFFSET F10CRD
  CALL TESTBOX
  OR   AX,AX
  JNZ  NEXTC

  MOV  CL,00H;  [F10]
  MOV  CH,44H
  MOV  AH,05H;      .
  INT  16H
NEXTC:
  POP  DS
  POP  SI
  RET

TESTBOX:
;     
; DX,CX = Y-, X-
;   ,  
;
  XOR AX,AX
  CMP DX,[SI+2]; Y0
  JB  TESTEND;    - 
  CMP DX,[SI+6]; Y1
  JA  TESTEND;    - 
  CMP CX,[SI];   X0
  JB  TESTEND;    - 
  CMP CX,[SI+4]; X1
  JA  TESTEND;    - 
  JMP TESTOUT
TestEnd:
  NOT AX
TestOut:
  RET

DISP:
;      HEX-
;  PUSH AX
;  PUSH BX
;  PUSH CX
;  PUSH DX
; DX,CX = ,
;  MOV  AL,20H
;  MOV  BL,96H
;  MOV  CX,1
;  MOV  AH,0EH
;  INT  10H
;  MOV  AL,20H
;  MOV  BL,96H
;  MOV  CX,1
;  MOV  AH,0EH
;  INT  10H

;  POP  DX
;  POP  CX
;  PUSH CX
;  PUSH DX

;  MOV  AX,CX
;  PUSH AX
;  MOV  AL,AH
;  AND  AL,0F0H
;  SHR  AL,4
;  CMP  AL,9
;  JBE  DIS0
;  ADD  AL,7
;DIS0:
;  ADD  AL,30H
;  MOV  BL,0EH
;  MOV  AH,0EH
;  MOV  CX,1
;  INT  10H
;  POP  AX

;  MOV  AL,AH
;  AND  AL,0FH
;  CMP  AL,9
;  JBE  DIS1
;  ADD  AL,7
;DIS1:
;  ADD  AL,30H
;  MOV  BL,0EH
;  MOV  AH,0EH
;  MOV  CX,1
;  INT  10H

;  POP  DX
;  POP  CX
;  PUSH CX
;  PUSH DX

;  MOV  AX,CX
;  PUSH AX
;  AND  AL,0F0H
;  SHR  AL,4
;  CMP  AL,9
;  JBE  DIS2
;  ADD  AL,7
;DIS2:
;  ADD  AL,30H
;  MOV  BL,0EH
;  MOV  AH,0EH
;  MOV  CX,1
;  INT  10H
;  POP  AX

;  AND  AL,0FH
;  CMP  AL,9
;  JBE  DIS3
;  ADD  AL,7
;DIS3:
;  ADD  AL,30H
;  MOV  BL,0EH
;  MOV  AH,0EH
;  MOV  CX,1
;  INT  10H

;  MOV  AL,20H
;  MOV  BL,96H
;  MOV  CX,1
;  MOV  AH,0EH
;  INT  10H

;  POP  DX
;  POP  CX
;  PUSH CX
;  PUSH DX

;  MOV  AX,DX
;  PUSH AX
;  MOV  AL,AH
;  AND  AL,0F0H
;  SHR  AL,4
;  CMP  AL,9
;  JBE  DIS4
;  ADD  AL,7
;DIS4:
;  ADD  AL,30H
;  MOV  BL,0EH
;  MOV  AH,0EH
;  MOV  CX,1
;  INT  10H
;  POP  AX

;  MOV  AL,AH
;  AND  AL,0FH
;  CMP  AL,9
;  JBE  DIS5
;  ADD  AL,7
;DIS5:
;  ADD  AL,30H
;  MOV  BL,0EH
;  MOV  AH,0EH
;  MOV  CX,1
;  INT  10H

;  POP  DX
;  POP  CX
;  PUSH CX
;  PUSH DX

;  MOV  AX,DX
;  PUSH AX
;  AND  AL,0F0H
;  SHR  AL,4
;  CMP  AL,9
;  JBE  DIS6
;  ADD  AL,7
;DIS6:
;  ADD  AL,30H
;  MOV  BL,0EH
;  MOV  AH,0EH
;  MOV  CX,1
;  INT  10H
;  POP  AX

;  AND  AL,0FH
;  CMP  AL,9
;  JBE  DIS7
;  ADD  AL,7
;DIS7:
;  ADD  AL,30H
;  MOV  BL,0EH
;  MOV  AH,0EH
;  MOV  CX,1
;  INT  10H

;  MOV  AL,13
;  MOV  BL,0EH
;  MOV  CX,1
;  MOV  AH,0EH
;  INT  10H

;DOUT:
;  POP  DX
;  POP  CX
;  POP  BX
;  POP  AX
;  RET

;==============================================================
;  EVEN      
; (   ALIGN 1),  
; ODD     .
; ALIGN  / .
;  :
even;             X     Y     X     Y  ;
ESCCRD      DW  007CH,0011H,012EH,001BH
DELCRD      DW  0165H,0011H,0200H,001BH
F10CRD      DW  007FH,0142H,00D3H,014CH
F11CRD      DW  00D4H,0142H,012AH,014CH
F12CRD      DW  012BH,0142H,01AFH,014CH
ENTCRD      DW  01B0H,0142H,01FFH,014CH
UPKCRD      DW  007AH,0020H,0203H,002AH
DNKCRD      DW  007AH,0134H,0203H,013FH
LEFCRD      DW  0065H,002BH,007AH,0131H
RGTCRD      DW  0205H,002BH,021BH,0131H
even
COLLOR      DB  98H
FIRST       DB  00H
even
OLDSTK      DW  2 DUP(0) ;      
ENVR        DW  14 DUP(0)
;PATH        DB  'C:\WORK\ASSM\SPMX43PT.EXE', 0
PATH        DB  'C:\ASSM\SPMX42PR.EXE', 0
;PATH        DB  'C'
;            DB  ':\'
CPTH        DW  32 DUP(0)
FILE        DB  '\SPMX42PR.EXE', 0 ; SPMX42PR.EXE
;Path       db  'C:\arh\rar16.exe', 0
even
ERR0        DB  ' Sorry, only for DOS 3.3 or higher', 13, 10, '$'
even
ERR1        DB  ' Int21h AH=4Ah failed', 13, 10, '$'
even
ERR2        DB  ' Int21h AH=4Bh failed', 13, 10, '$'
even
ERR3        DB  ' Current Path allocation error', 13, 10, '$'
even
CLIPBD_MESS DB  "ABCD",0,0 ;  -   
even
PRESS_KEY   DW  0          ;  
even

END_PROGRAMM = $

END STRATUP